# usage 
# DEMO
# runs neural net
#  DJCM August 1998
global sigmawin ;
global sigmawout ;
global sigmawbias ;
global in ; 
global out ; 
global bias ; 
global inbiasoutstring = "in u 1:2 w l 1, bias u 1:2 w l 7, out u 1:2 w l 8," ;
initial = 0.25 ;
global beta = 2 ;
global alphag = 1.0 ;
global alphag0 = 1.0 ;
global xt ;
global M ; global ED ; global EW ; global H ; global xlist
global dologgw = 0 ; # whether to log the gradient
global loggw = [] ;
				#
# define data
#
state = 0 ; State = 48 ; # State is the maximum state, at which we cycle
while (1)
  printf ("state =  %d \n" , state ) ; 
  ans = mymenu("Neural net",
	       "Random networks - H = 3, 10",
	       "Random networks - H = 25 ",
	       "Random networks - vary sigma_w ",
	       "Steepest descents - live",
	       "Graphs",
	       "save",
#	       "restore",
	       "Steepest descents - reshow",
	       "Graphs",
	       "Weight decay - live",
	       "save",
	#       "restore",
	       "Weight decay - reshow",
	       "Langevin method",
	       "Graphs",
	       "save",
	 #      "restore",
	       "Langevin method results - reshow",
	       "Graphs",
#	       "Hybrid Monte Carlo",
	       "quit",
	       "keyboard",
	       "quit"
	       ) ;
  if ( ans == 0 ) 
    state ++ ; 
    if ( state > State )  # cycle through options
      state = 1 ; 
    endif
  else
    state = ans ;
  endif
  
  randn("seed",0.243) ; # fix the randomizer
  rand("seed",0.243);
  initgnu();			# set up graphics
  counter = 0 ; 
  purge_tmp_files ;

				# find the routine corresponding to state
				# by incrementing a counter and comparing.
  if(++counter && state==counter)
				# 1  Random networks - movies, including
				# hidden units
    gnuSETxy ;
    xmax = 6 ;
    xmin = -xmax ;
    gset xrange [-6:6] ;
    sigmawin = 1.5 ; sigmawout = 4 ; sigmawbias = 1.5 ;
    Xn = 100 ;
    makexlist ;
    
    Hmin = 3 ; Hmax = 10 ; H = Hmin ; dH = 7 ;
    while(H<=Hmax)
      qcom = sprintf ("gset title 'H = %d' \n", H ) ;
      eval ( qcom ) ; 
      sigmaw = setsigmaw(  sigmawin ,  sigmawbias ,sigmawout/sqrt(H) ) ;
      [in,bias,out] = network( H , 3,6 , 0.5 , 1.6 ) ; 
      v0 = randn ( 3*H+1 ,1) ;
 gplot	in u 1:2 w l 1, bias u 1:2 w l 7, out u 1:2 w l 8 ;	
      Movies = 40 ;
      memory = 0.95 ; # memory for movie 
      w = v0 .* sigmaw ;
	input("press return for function");
      showcurves(w,xlist,1,6,inbiasoutstring,"") ;
      if ( Movies > 0 ) 
	input("press return for movie");
      endif
      for movies = 1 : Movies 
	showcurves(w,xlist,1,6,inbiasoutstring,"") ;# blue (6) is the color for samples from prior
	w = memory * w + sqrt((1.0-memory^2)) * randn(size(w)) .* sigmaw  ;
      endfor
      if ( H < Hmax ) 
	input("press return");
      endif
      H = H + dH ;
    endwhile
    
  elseif(++counter && state==counter)	# 2 movie of random net functions
				# without hidden units
    sigmawin = 1.5 ; sigmawout = 0.75 ; sigmawbias = 1.5 ;
    xmax = 6 ;    xmin = -xmax ;
    Xn = 75 ;
    gnuSETxy ;
    makexlist ;
    gset xrange [-6:6] ;
    
    H = 25 ;
    qcom = sprintf ("gset title 'H = %d' \n", H ) ;
    eval ( qcom ) ; 
    [in,bias,out] = network( H , 1.3,6 , 0.4 , 3.5 ) ; 
#    [in,bias,out] = network( H , 3,6 , 0.5 , 1.6 ) ; 
    sigmaw = setsigmaw(  sigmawin ,  sigmawbias ,sigmawout ) ;
    Movies = 100 ;
    memory = 0.95 ; # memory for movie 
    
    v0 = randn ( 3*H+1 ,1) ;
    w = v0 .* sigmaw ;
    for movies = 1 : Movies 
      showcurves(w,xlist,0,6,inbiasoutstring,"") ; 
      w = memory * w + sqrt((1.0-memory^2)) * randn(size(w)) .* sigmaw  ;
    endfor
    
  elseif(++counter && state==counter)	# 3 varying sigmas
    xmax = 6 ;
    xmin = -xmax ;
    Xn = 175 ;
    gnuSETxy ;
    makexlist ;
    
    H = 25 ;
    [in,bias,out] = network( H , 1.3,6 , 0.4 , 3.5 ) ; 
    Numlines = 3 ;
    memory = 0.95 ; # memory for movie 
    
    v0 = randn ( 3*H+1 , Numlines ) ;
    sigmawin = 1 ; sigmawout = 1 ; sigmawbias = 1 ;
    smax = 10 ; smin = 0.1 ; hiddens = 0 ;
    samples = 15 ;
    varysigmaw (v0,xlist,samples,hiddens, smax , smin ) ;

    if ( 0 ) 
	    printf "again, showing the hidden activities\n" ; 
      hiddens = 1 ; 
      v0 = v0(:,1) ; 
      varysigmaw (v0,xlist,samples,hiddens, smax , smin ) ;
    endif
    state = state + 3 ; # skip ahead and load it

            # do steepest descents for real.
  elseif(++counter && state==counter) # 4 steepest, alpha = 0.0 
    load -force dat6 ;			# loads x and t
    xt = [x,t] ;
    sigmawin = initial ; sigmawout = initial ; sigmawbias = initial ;
    xmax = 6 ;    xmin = -xmax ;
    Xn = 40 ;
    gnuSETxy ;
    makexlist ;

    eta = 0.005;
    H = 25 ;    [in,bias,out] = network( H , 3,6 , 0.5 , 1.6 ) ;
    sigmaw = setsigmaw(  sigmawin ,  sigmawbias ,sigmawout ) ;
    v0 = randn ( 3*H+1 ,1) ;
    w = v0 .* sigmaw ;
    Loop = 10000 ;
    alphag = 0.0 ; 
    lperiod = 1 ;  lperiod2 = 101 ; turn1 = 20 ;
    [w,logfile,wl]  = steepest ( w , Loop , eta , alphag, lperiod ,  lperiod2 , turn1 , "" )  ;
#    loggw 
#    input("ready for ED?") ;
  elseif(++counter && state==counter) # 5 results of steepest descents
    graphs_steepest ;
    
  elseif(++counter && state==counter) # 6 save history
    save steepweights wl logfile H w
    
  elseif(++counter && state==counter) # 7 restore history
    printf ("restoring weights...\n") ; 
    load -force steepweights

#  elseif(++counter && state==counter) # 8 reshow history
    load -force dat6 ;
    xt = [x,t] ;
    xmax = 6 ;
    xmin = -xmax ;
    Xn = 40 ;
    gnuSETxy ;
    makexlist ;

    fakesteepest ( wl , logfile , "" ) ; 
#
    #
    #showcurves(w,xlist,0,1,"",",xt u 2:3 w p 1 3");
				# debug> replot
				# debug> gset term postscript
				# debug> gset output "overfit.ps"
				# debug> replot

    
  elseif(++counter && state==counter) # 9 results of steepest descents
    graphs_steepest ;
    state = state + 2 ; # skip ahead and load it

  elseif(++counter && state==counter) # 10 steepest with weight decay
    load -force dat6 ; 
    xt = [x,t] ;

    sigmawin = initial ; sigmawout = initial ; sigmawbias = initial ;
    xmax = 6 ;
    xmin = -xmax ;
    Xn = 40 ;
    makexlist ;
				# 0.03 was just too big 
    eta = 0.005;
    H = 25 ;
    [in,bias,out] = network( H , 3,6 , 0.5 , 1.6 ) ;
    sigmaw = setsigmaw(  sigmawin ,  sigmawbias ,sigmawout ) ;
    v0 = randn ( 3*H+1 ,1) ;
    w = v0 .* sigmaw ;
    Loop = 10000 ;
    alphag = alphag0 ; Alphaloop = 1 ; # steepest
    for alphaloop = 1:Alphaloop
      gnuSETxy ;
      alphastring = sprintf ( " (alpha = %6.2f)" , alphag ) ; 
      lperiod = 1 ;  lperiod2 = 101 ; turn1 = 20 ;
      [w,logfile,wl]  = steepest ( w , Loop , eta , alphag, lperiod ,  lperiod2 , turn1 , alphastring ) ;
      graphM(logfile,15,10000) ;
      if alphaloop < Alphaloop
	alphag = alphag * (1000**(0.1)) ;
      endif
    endfor

    
  elseif(++counter && state==counter) # 11 save history
    save alphaweights wl logfile H alphag w
    
  elseif(++counter && state==counter) # 12 restore history
    printf ("restoring alpha weights...\n") ; 
    load -force alphaweights

#  elseif(++counter && state==counter) # 13 reshow history
    load -force dat6 ;
    xt = [x,t] ;
    xmax = 6 ;
    xmin = -xmax ;
    Xn = 40 ;
    gnuSETxy ;
    makexlist ;

    alphastring = sprintf ( " (alpha = %6.2f)" , alphag ) ; 
    
    fakesteepest ( wl , logfile , alphastring ) ;
#    input ("see graphs when ready") ;
    graphM(logfile,15,10000,0,1) ;

    state = state + 3 ; # skip ahead and load it

  elseif(++counter && state==counter) # 14 langevin
    load -force dat6 ;
				# loads x and t
    xt = [x,t] ;

    Loop = 30000 ;
    sigmawin = initial ; sigmawout = initial ; sigmawbias = initial ;
    xmax = 6 ;
    xmin = -xmax ;
    Xn = 25 ;
    gnuSETxy ;
    makexlist ;
				# 0.03 was just too big 
    eta = 0.005 ;
    H = 25 ;
				# initial condition
    [in,bias,out] = network( H , 3,6 , 0.5 , 1.6 ) ;
    sigmaw = setsigmaw(  sigmawin ,  sigmawbias ,sigmawout ) ;
				# weight decay
    alphag =alphag0 ; # langevin 
    v0 = randn ( 3*H+1 ,1) ;
    w = v0 .* sigmaw ;
#    input("ready for langevin?") ;
    gset title "Langevin Monte Carlo" ;
    global accepts = 0  ; global rejects = 0 ; global T = 1 ; global logtime = 1 ; 
    global dologgw = 0 ;
    global loggw = [] ;
    lperiod = 1 ;  lperiod2 = 201 ; turn1 = 20 ;
    [w,logfile,wl]  = langevinmc ( w , Loop , eta , alphag, lperiod ,  lperiod2 , turn1 , "" )  ;

  elseif(++counter && state==counter) # 7 results of langevin
    graphM(logfile,50,30000,1,0) ;
    
  elseif(++counter && state==counter) # 8 save history
    save langweights wl logfile H alphag w ;
    
  elseif(++counter && state==counter) # 9 restore history
    printf ("loading langevin weights\n");
    load -force langweights ;

#  elseif(++counter && state==counter) # 10 reshow history
    load -force dat6 ;
    xt = [x,t] ;

    xmax = 6 ;
    xmin = -xmax ;
    Xn = 40 ;
    gnuSETxy ;
    makexlist ;
    ys = fakelangevin ( wl , logfile ) ;
    ymean = mean(ys')' ;
    ystd = std(ys')' ;
	yupper = ymean + ystd ;
	ylower = ymean - ystd ;
    xys = [xlist,ys] ;
    xymean = [xlist,ymean,yupper,ylower,ystd] ;
    s = size(ys) ; C = s(2) ;

    col = 3 ;
    for c = 1:C
      if ( c == 1 )
	com = sprintf("gplot xys u 2:%d w l 5", col) ;
      else
	com = sprintf("%s,xys u 2:%d w l 5", com, col) ;
      endif
      col ++ ;
    endfor
    input("ready?") ;
    comt = sprintf("gset title '%d samples' " , C ) ;
	eval (comt )  ;
    com = sprintf("%s,%s",com,"xt u 2:3 w p 1 3")  ;
#    com = sprintf("%s,%s,%s",com, "xymean u 2:3 w l 4","xt u 2:3 w p 1 3")  ;
#    printf (com) ; 
    eval(com);
    input("ready?") ;
    comtm = sprintf("gset title '%d samples -> mean, error bars (one s.d.)' " , C ) ;
	eval (comtm )  ;
    commean = sprintf ("gplot xymean u 2:3 w l 4, xymean u 2:4 w l 3, xymean u 2:5 w l 3,xt u 2:3 w p 1 3")  ;
#    commean = sprintf ("gplot xymean u 2:3 w l 1, xymean u 2:4 w l 3, xymean u 2:5 w l 3,xt u 2:3 w p 1 3")  ;
    eval(commean);
    input("ready?") ;
	eval (comt )  ;
    eval(com);

  elseif(++counter && state==counter) # 7 results of langevin
    graphM(logfile,50,30000,1,0) ;

  elseif(++counter && state==counter)
    break ;

  elseif(++counter && state==counter)
    keyboard;

  else
    break ;

  endif

endwhile

#############################################################










#    sigmawin = 1.5 ; sigmawout = 0.75 ; sigmawbias = 1.5 ;
#    alphag = setsigmaw(  sigmawin ,  sigmawbias ,sigmawout ) ;
				# what I wanted to do was to have an alpha
				# vector, but maybe this  complicates life.
