function ret = gradM ( w )
#
# gradient of objective function for Bayesian neural net with 1:H:1
#
	global a ;  # activations
	global y ;  # outputs
	global xh ;  # hidden's outputs
	global yh ;  # hidden's outputs
	global e ;  # errors
	global alphag ; 
	global beta ; 
	global x ; # inputs 
	global t ; # targets
	global H ;
	global win ; 
	global wbout ; 
	global wout ; 

	y = forwardpass(w,x) ;

	e = t - y   ;	     # compute errors

# end of forward pass

        yhderiv = 1.0 .- yh .** 2 ;

	gwout = xh' * e ;	     # compute the gradient


# errors and deltas
  eh = e * wout'  ;

  dh = yhderiv .* eh ;
  gwin = x' * dh ;
  gw = [ reshape( gwin , 2*H , 1 ) ;  gwout ] ;	    
	ret =  alphag * w - beta * gw ;

endfunction


